/* ----------------------------------------------------------------------------
 *  dakaXTestP5
 * ----------------------------------------------------------------------------
 *  prog: max.rheiner@zhdk.ch / Zhdk / Interaction Design
 *  date: 11/16/2011
 * ----------------------------------------------------------------------------
 */
  
import processing.serial.*;

final static byte CMD_WRITE_DOUT2  = 1;
final static byte CMD_READ_DIN3    = 2;
final static byte CMD_READ_AD0     = 3;
final static byte CMD_RET_READ_DIN3= 4;
final static byte CMD_RET_READ_AD0 = 5;

DakaX  dakaX;

void setup()
{
  size(800,600,P3D);
  
  String portName = "COM43";  // osx = /dev/tty.usbbluetooth???
  
  println("Open SerialPort: " + portName );
  dakaX = new DakaX(this, 
                    portName, 
                    38400);
                    //115200);
                 
  smooth();  
  strokeWeight(3);  
}
 
void draw()
{
  dakaX.update();
  
  background(0); 
  
  translate(width/2,height/2);
  drawRefObj();  
}

void drawRefObj()
{
  pushMatrix();
     // sensor rotation
    rotateZ(-dakaX.euler()[2]);
    rotateX(-dakaX.euler()[1]);
    rotateY(-dakaX.euler()[0]);
    
    drawCoordSys();

    scale(2);
    drawBox();
  popMatrix();
}

void drawCoordSys()
{
  pushMatrix();  
    scale(100,100,100);    
    
    // x axis
    stroke(255,110,110);
    line(0,0,0,1,0,0);
    
    // y axis
    stroke(110,255,110);
    line(0,0,0,0,1,0);
    
    // z axis
    stroke(110,110,255);
    line(0,0,0,0,0,1);
    
  popMatrix();
}

void drawBox() 
{
  noStroke();
  beginShape(QUADS);
  
  //Z+ (to the drawing area)
  fill(#0000ff);
  vertex(-30, -5, 20);
  vertex(30, -5, 20);
  vertex(30, 5, 20);
  vertex(-30, 5, 20);
  
  //Z-
  fill(#00ffff);
  vertex(-30, -5, -20);
  vertex(30, -5, -20);
  vertex(30, 5, -20);
  vertex(-30, 5, -20);
  
  //X-
  fill(#ffff00);
  vertex(-30, -5, -20);
  vertex(-30, -5, 20);
  vertex(-30, 5, 20);
  vertex(-30, 5, -20);
  
  //X+
  fill(#ff0000);
  vertex(30, -5, -20);
  vertex(30, -5, 20);
  vertex(30, 5, 20);
  vertex(30, 5, -20);
  
  //Y-
  fill(#ff00ff);
  vertex(-30, -5, -20);
  vertex(30, -5, -20);
  vertex(30, -5, 20);
  vertex(-30, -5, 20);
  
  //Y+
  fill(#00ff00);
  vertex(-30, 5, -20);
  vertex(30, 5, -20);
  vertex(30, 5, 20);
  vertex(-30, 5, 20);
  
  endShape();
}

void keyPressed()
{
  switch(key)
  {
  case '1':
    dakaX.requestSensorData();
    println("request data");
    break;
  case ' ':
    // set home pos
    dakaX.setHomeRot();
    break;
  case 'x':
    // reset home pos
    dakaX.resetHomeRot();
    break;
  }
}

void onDakaXMessage(int cmdId,DakaX dakaX)
{
  /*
  switch(cmdId)
  {
  case ????:
    dakaX.getByte()
    break;
  }
  */
}
